# -*- coding:utf-8 -*-
from flask import request
from huansi_utils.webapi import ApiController

from app import api
from app.install.install_service import InstallService


@api('install')
class InstallAPI(ApiController):

    @api('test/<int:s>')
    def get_test(self, s):
        import time
        print(1)
        time.sleep(int(s))
        return 1

    @api('runner')
    def get_list(self):
        '''
        安装runner
        :return:
        '''
        return InstallService().install_runner()

    @api('runner/step1')
    def get_install_runner_step1(self):
        '''
        安装runner1
        :return:
        '''
        return InstallService().install_huansi_runner_step1()

    @api('runner/step2')
    def get_install_runner_step2(self):
        '''
        安装runner2
        :return:
        '''
        return InstallService().install_huansi_runner_step2()

    @api('runner/step3')
    def get_install_runner_step3(self):
        '''
        安装runner3
        :return:
        '''
        return InstallService().install_huansi_runner_step3()

    @api('remote_server/docker/')
    def get_install_remote_server_docker(self):
        '''
        远端服务器安装docker
        :return:
        '''
        return InstallService().install_remote_service_docker()
